#pragma rtGlobals=1		// Use modern global access method.
// Protocol Template

Menu "tClamp16"
	SubMenu "Oscillo Protocol"
		"E7PM7A_Step_Injection", tClamp16SetE7PM7A_Step_Inject() // any name of setting protocol
	End
End

Function tClamp16SetE7PM7A_Step_Inject() 					//any name of setting protocol
	tClamp16_FolderCheck()
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:Packages:tClamp16

	String/G SelectedProtocol = "tClamp16_E7PM7A_Step_Inject()"	// any name of protocol
	String/G StrITC16SeqDAC = "0012"				// must be same length
	String/G StrITC16SeqADC = "0124"
	Variable/G RecordingCheckADC0 = 1			//Select recording channels
	Variable/G RecordingCheckADC1 = 1
	Variable/G RecordingCheckADC2 = 1
	Variable/G RecordingCheckADC3 = 0
	Variable/G RecordingCheckADC4 = 1
	Variable/G RecordingCheckADC5 = 0
	Variable/G RecordingCheckADC6 = 0
	Variable/G RecordingCheckADC7 = 0
	Variable/G OscilloCmdPulse0 = 0.1
	Variable/G OscilloCmdPulse1 = 0.5
	Variable/G OscilloCmdPulse2 = 0.125
	Variable/G OscilloCmdPulse3 = 0.25
	Variable/G OscilloCmdPulse4 =0.125
	Variable/G OscilloCmdPulse5 = 0.25
	Variable/G OscilloCmdPulse6 = 0.25
	Variable/G OscilloCmdPulse7 = 0.25
	Variable/G OscilloCounterLimit = 10				//Sweep number
	Variable/G OscilloSamplingNpnts = 10240			//Number of Sampling Points at each channel
	Variable/G OscilloITC16ExtTrig = 0				//0: off, 1: on
	Variable/G OscilloITC16Output = 1				//0: off, 1: on
	Variable/G OscilloITC16Overflow = 1				//0: 
	Variable/G OscilloITC16Reserved = 0			// Reserved
	Variable/G OscilloITC16Period = 25				// must be between 5 and 65535. Each sampling tick is 1 micro sec.

	tClamp16ApplyProtocolSetting()

	SetDataFolder fldrSav0
end

Function tClamp16_E7PM7A_Step_Inject() //same as StrAcquisitionProcName and SelectedProtocol
	NVAR bit = root:Packages:tClamp16:RecordingBit
	NVAR OscilloCounter = root:Packages:tClamp16:OscilloCounter
	
	Variable i = 0
	For(i = 0; i < 8; i += 1)
		If(bit & 2^i)
			Wave OscilloADC = $("root:Packages:tClamp16:OscilloADC" + Num2str(i))
			NVAR OscilloCmdPulse = $("root:Packages:tClamp16:OscilloCmdPulse" + Num2str(i))		//
			NVAR OscilloCmdOnOff = $("root:Packages:tClamp16:OscilloCmdOnOff" + Num2str(i))		//
	
			If(OscilloCmdOnOff)
				OscilloADC[0, trunc(numpnts(OscilloADC)*0.2) - 1] = 0					// create DAC output data in volt
				OscilloADC[trunc(numpnts(OscilloADC)*0.2),  trunc(numpnts(OscilloADC)*0.8 - 1)] = (-3 + OscilloCounter)*OscilloCmdPulse
				OscilloADC[trunc(numpnts(OscilloADC)*0.8), ] = 0
				OscilloADC *= 3200					// scale into point
			else
				OscilloADC[0, ] = 0
				OscilloADC *= 3200
			endif
		endif
	endFor
end


